<?php
ini_set('display_errors', 1);

require_once '../../../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//validation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";

$postdata = json_decode(file_get_contents("php://input"), true);

// checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$branch_id = $postdata['branch_id'];
$institution_id = $postdata['institution_id'];

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

// Validate institution_id and branch_id
$academicSessionId = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if (!$academicSessionId) {
    errorreturn("Invalid institution_id");
}

$isBranchClassSubjectValid = checkBranchClassSubject($conn_rjllearning_specific, $branch_id, null, null, $institution_id);
if (!$isBranchClassSubjectValid) {
    errorreturn("Invalid branch_id.");
} 

$function_type = trim($postdata['function_type']);

function get_vendor_details($conn_rjllearning_specific, $institution_id, $branch_id, $limit, $offset)
{
    $sql = "SELECT count(DISTINCT vendor_name) as total_rows FROM unmarked_transaction WHERE institution_id =? AND branch_id = ?";
    $array_params = [$institution_id, $branch_id];
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];
    
    // echo $limit;

    // Query to get the unique vendor names based on limit and offset
    if ($limit == 'all') {
        $sql_session = "
            SELECT DISTINCT vendor_name FROM unmarked_transaction 
            WHERE institution_id = ? AND branch_id = ?
        ";
        // echo "hello";
        // print_r ($sql_session);
        $array_params = [$institution_id, $branch_id];
    } else {
        $sql_session = "
            SELECT DISTINCT vendor_name FROM unmarked_transaction 
            WHERE institution_id = ? AND branch_id = ?
        ";
        $array_params = [$institution_id, $branch_id];

        $sql_session .= " LIMIT " . $offset . " ," . $limit . "";
    }

    $stmt = $conn_rjllearning_specific->prepare($sql_session);
    $stmt->execute($array_params);
    $session_rows = $stmt->fetchAll();
    
    // print_r ($session_rows);
    
    if (empty($session_rows)) {
        errorreturn("No vendors found");
    }

    // Format the result to include only the vendor names
    $formattedVendors = [];
    foreach ($session_rows as $row) {
        $formattedVendors[] = ['name' => $row['vendor_name']];
    }

    if (count($session_rows) < 50) {
        return [
            'total_rows' => $totalrows,
            'vendor_info' => $formattedVendors,
            'maxreach' => 1
        ];
    } else {
        return [
            'total_rows' => $totalrows,
            'vendor_info' => $formattedVendors,
            'maxreach' => 0
        ];
    }
}

if ($postdata['function_type'] == "fetch_vendors") {

    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = get_vendor_details($conn_rjllearning_specific, $institution_id, $branch_id, $limit, $offset);
        
    } else {
        $success['data'] = get_vendor_details($conn_rjllearning_specific, $institution_id, $branch_id, $limit, null);
    }
    
    successreturn($success);
}
